/*========================================================================*/
/* lamwait.c - Ulazak u kriticnu sekciju po Lamport-ovom algoritmu.       */
/*========================================================================*/
#include "lamport.h"           /* Strukture podataka za Lamport-ov alg.   */
#include <lib$routines.h>     /* Prototipovi LIB$ funkcija.               */
#include <jpidef.h>           /* Definicije JPI$ konstanti.               */
/*------------------------------------------------------------------------*/
#define CEKA_BIRANJE 0.5
#define CEKA_IZLAZAK 2.0
/*------------------------------------------------------------------------*/
void lam_wait () {
  int i, j, max;
  const int jpi_indeks = JPI$_PROC_INDEX; 
  const double ceka_biranje = CEKA_BIRANJE, ceka_izlazak = CEKA_IZLAZAK;

  lib$getjpi (&jpi_indeks, 0, 0, &i, 0, 0); /* Indeks procesa (1, 2, ...) */
  choos[i] = 1;                             /* Biranje broja.             */
  for (j=0; j<=MXPROC; j++) if (max < numb[j]) max = numb[j];
  numb[i] = max + 1;
  choos[i] = 0;

  for (j=0; j<=MXPROC; j++) {               /* Cekanje na svoj red.       */
    while (choos[j]) lib$wait (&ceka_biranje);
    while (numb[j] && (numb[j]<numb[i] || numb[j]==numb[i]&&j<i))
      lib$wait (&ceka_izlazak);
  }
} /*======================================================================*/
