// proces.cpp - Definicije podataka i funkcija o procesima.

#include "proces.h"

Proces *Proces::prvi    = 0;        // Prvi u listi svih procesa.
Proces *Proces::zadnji  = 0;        // Zadnji u listi svih procesa.
Proces *Proces::spreman = 0;        // Prvi u listi spremnih procesa.
Proces *Proces::radi    = 0;        // Proces u stanju radi.
short   Proces::kvant;              // Kvant vremena [1/18.2 s = 54.94 ms].

void Proces::stavi_spreman (Proces *proc) { // Stavi proces u listu spr.
  Proces *tekuci=spreman, *prethodni=0;
  proc->stanje = SPREMAN;
  while (tekuci && tekuci->prio>=proc->prio)
    { prethodni = tekuci;  tekuci = tekuci->sledeci; }
  proc->sledeci = tekuci;
  (prethodni ? prethodni->sledeci : spreman ) = proc;
}

void Proces::blokiraj (Proces *&prvi,     // Blokiraj tekuci proces.
		       Proces *&zadnji) {
  radi->stanje = BLOKIRAN;
  radi->sledeci = 0;
  zadnji = (zadnji ? zadnji->sledeci : prvi) = radi;
}

#include <dos.h>
void Proces::oduzmi_procesor () {    // Oduzmi procesor tekucem procesu.
  unsigned spx, ssx;
  asm {	push ax; push bx; push cx; push	dx
	push si; push di; push bp; push ds; push es
	mov ssx, ss; mov spx, sp
  }
  radi->sp = MK_FP (ssx, spx);

  radi          = spreman;
  spreman       = spreman->sledeci;
  radi->sledeci = 0;
  radi->stanje  = RADI;
  kvant         = KVANT;

  ssx = FP_SEG (radi->sp); spx = FP_OFF (radi->sp);
  asm { mov ss, ssx; mov sp, spx
	pop es; pop ds; pop bp; pop di; pop si
	pop dx; pop cx; pop bx; pop ax
      }
}

void interrupt Proces::meri_vreme () {     // Odbrojavanje kvanta vremena.
  if (--kvant == 0) { stavi_spreman (radi); oduzmi_procesor (); }
}

void Proces::novi_proces (int ident, int prio, // Formiranje procesa.
			  void *prog, void *podat, void *stek) {
  Proces *novi = new Proces;
  if (novi) {
    novi->sledeci = novi->naredni = 0;
    novi->ident = ident; novi->prio = prio;
    novi->pokaz = 0;
    zadnji = (zadnji ? zadnji->naredni : prvi) = novi;
    unsigned *st = (unsigned *)stek;
    *st-- = 0;
    *st-- = FP_SEG (prog);
    *st-- = FP_OFF (prog);
    *st-- = FP_SEG (pokreni_proces);
    *st-- = FP_OFF (pokreni_proces);
    for (int i=0; i<7; i++) *st-- = 0;
    *st-- = FP_SEG (podat);
    *st-- = FP_SEG (podat);
    novi->sp = st;

    stavi_spreman (novi);
  }
}

void interrupt Proces::pokreni_proces () {}

