/* proces.h - Deklaracije podataka i funkcija za obradu procesa.          */

#ifndef _proces_h_
#define _proces_h_

class Proces {
  enum Stanje { RADI, SPREMAN, BLOKIRAN };  // Stanja procesa.

  // KONTROLNI BLOK PROCESA (pcb)
  int     ident;                   // Identifikator procesa.
  int     prio;                    // Prioritet procesa.
  Stanje  stanje;                  // Stanje procesa.
  void   *sp;                      // Ocuvani pokazivac steka.
public:
  Proces *naredni;                 // Naredni u listi svih procesa.
  Proces *sledeci;                 // Sledeci u raznim listama proc.
  void  *pokaz;                    // Pokazivac opste namene.
  // Ostali sadrzaj PCB-a.

  // METODE ZA OBRADU PROCESA
  static void stavi_spreman (Proces *proc); // Stavi proces u listu sprem.
  static void blokiraj (Proces *&prvi,      // Blokiraj tekuci proces.
			Proces *&zadnji);
  static void oduzmi_procesor ();        // Oduzmi procesor tekucem proc.
  static void interrupt meri_vreme ();   // Odbrojavanje kvanta vremena.
  static void novi_proces (int ident, int prio,    // Formiranje procesa.
	      void *prog, void *podat, void *stek);
  static void *uzmi_pokaz ()             // Dohvati pokazivac opste namene.
    { return radi->pokaz; }

private:
  static interrupt void pokreni_proces (); // Pokreni novi proces.

  // ZAJEDNICKI PODACI ZA SVE PROCESE

  enum { KVANT = 10 };            // Kvant vremena [1/18.2 s = 54.94 ms].

  static Proces *zadnji;          // Zadnji u listi svih procesa.
  static Proces *spreman;         // Prvi u listi spremnih procesa.
  static short kvant;             // Preostali deo kvanta vremena.
public:
  static Proces *prvi;            // Prvi u listi svih procesa.
  static Proces *radi;            // Proces u stanju radi.

};

#endif
