// sanduk.cpp - Definicije globalnih podataka za rad sa sanducima.

#include "sanduk.h"
#include "sistem.h"
#include "proces.h"
#include <string.h>

// SLANJE PORUKE.

void    Sanduk::sis_salji (const void *sadrzaj, int duz) {
  Sistem::poziv_os (Sistem::SAND_SALJI, this, sadrzaj, &duz);
}

void    Sanduk::    salji () {
  Sanduk *sanduk = (Sanduk *) Sistem::par1;
  char   *sadrzaj= (char *)   Sistem::par2;
  int     duzina = * (int *)  Sistem::par3;
  Poruka *poruka = new Poruka;  // Preuzimanje poruke.
  if ((poruka->duzina = duzina) != 0) {
    poruka->sadrzaj = new char [duzina];
    for (int i=0; i<duzina; i++) poruka->sadrzaj[i] = sadrzaj[i];
  } else poruka->sadrzaj = 0;
  poruka->sledeci = 0;
  if (sanduk->stanje == PROCES) {  // Isporuka poruke procesu.
    Proces *proces = (Proces *) sanduk->poc;
    proces->pokaz = poruka;
    sanduk->poc   = proces->sledeci; proces->sledeci = 0;
    if (! sanduk->poc)
      { sanduk->kraj = 0;  sanduk->stanje = PRAZAN; }
    Proces::stavi_spreman (proces);
  } else {                              // Stavljanje poruke u red.
    if (sanduk->stanje == PRAZAN) {
      sanduk->poc = poruka; sanduk->stanje = PORUKA;
    } else ((Poruka *) sanduk->kraj)->sledeci = poruka;
    sanduk->kraj = poruka;
  }
}

// PRIJEM PORUKE.

void    Sanduk::sis_primi (void *sadrzaj, int &duzina) {
  Sistem::poziv_os (Sistem::SAND_SALJI, this, sadrzaj, &duzina);
}

void    Sanduk::    primi () {
  Sanduk *sanduk  = (Sanduk *) Sistem::par1;
  char   *sadrzaj = (char *)   Sistem::par2;
  Poruka *poruka;
  if (sanduk->stanje == PORUKA) {  // Isporuka poruke procesu.
    poruka = (Poruka *) sanduk->poc;
    sanduk->poc = poruka->sledeci; poruka->sledeci = 0;
    if (sanduk->poc == 0)
      { sanduk->kraj = 0;  sanduk->stanje = PRAZAN; }
  } else {                              // Stavljanje procesa u red.
    sanduk->stanje = PROCES;
    Proces::blokiraj ((Proces *)sanduk->poc, (Proces *)sanduk->kraj);
    Proces::oduzmi_procesor ();
    poruka = (Poruka *) Proces::radi->pokaz;
  }
  int duzina  = poruka->duzina;         // Prenos sadrzaja poruke.
  for (int i=0; i<duzina; i++) sadrzaj[i] = poruka->sadrzaj[i];
  delete [] poruka->sadrzaj;  delete poruka;
  * (int *) Sistem::par3 = duzina;
}

// ISPITIVANJE STANJA SANDUKA.

Sanduk::Stanje Sanduk::sis_stanje () {
  Stanje stanje;
  Sistem::poziv_os (Sistem::SAND_STANJE, this, &stanje);
  return stanje;
}

void    Sanduk::    stanje_ (){
  * (Stanje *) Sistem::par2 = ((Sanduk *) Sistem::par1)->stanje;
}

// FORMIRANJE SANDUKA (+ OTVARANJE).

Sanduk *Sanduk::sis_novi (const char *ime) {
  Sistem::poziv_os (Sistem::SAND_NOVI, (void *)ime);
  return (Sanduk *) Sistem::par2;
}

void    Sanduk::novi () {
  char   *ime = (char *) Sistem::par1;
  Sanduk *novi = nadji (ime);
  if (novi) novi->broj++;
  else {
    novi = new Sanduk;
    novi->sledeci   = 0;
    novi->prethodni = zadnji;
    zadnji = (zadnji ? zadnji->sledeci : prvi) = novi;
    novi->ime = new char [strlen(ime) + 1];  strcpy (novi->ime, ime);
    novi->broj = 1;
    novi->stanje = PRAZAN;
    novi->prvi   = novi->zadnji = 0;
  }
  Sistem::par2 = novi;
}

// POCETAK RADA SA SANDUKOM.

Sanduk *Sanduk::sis_otvori (const char *ime) {
  Sistem::poziv_os (Sistem::SAND_OTVORI, (void *)ime);
  return (Sanduk *) Sistem::par2;
}

void    Sanduk::    otvori () {
  Sanduk *sanduk = nadji ((char *)Sistem::par1);
  if (sanduk) sanduk->broj++;
  Sistem::par2 = sanduk;
}

// KRAJ RADA SA SANDUKOM.

void    Sanduk::sis_zatvori () {
  Sistem::poziv_os (Sistem::SAND_ZATVORI, this);
}

void    Sanduk::    zatvori () {
  Sanduk *sanduk = (Sanduk *) Sistem::par1;
  if (sanduk->broj > 0) sanduk->broj--;
}

// BRISANJE SANDUKA.

int     Sanduk::sis_brisi (const char *ime) {
  int uspeh;
  Sistem::poziv_os (Sistem::SAND_BRISI, (void *) ime, &uspeh);
  return uspeh;
}

void    Sanduk::    brisi () {
  Sanduk *sanduk = nadji ((char *)Sistem::par1);
  int     uspeh;
  if ((uspeh = sanduk != 0              &&
	       sanduk->stanje == PRAZAN &&
	       sanduk->broj   == 0         ) != 0) {
    (sanduk->prethodni ?
       sanduk->prethodni->sledeci :
       prvi                        ) = sanduk->sledeci;

    (sanduk->sledeci ?
       sanduk->sledeci->prethodni :
       zadnji                      )= sanduk->prethodni;
    delete sanduk;
  }
  * (int *) Sistem::par2 = uspeh;
}

// NALAZENJE SANDUKA PO IMENU.

Sanduk *Sanduk::    nadji (const char *ime) {
  Sanduk *tekuci = prvi;
  while (tekuci && strcmp(ime,tekuci->ime)) tekuci = tekuci->sledeci;
  return tekuci;
}

// ZAJEDNICKI PODACI KLASE.

Sanduk *Sanduk::prvi   = 0;           // Prvi u listi svih sanduka.
Sanduk *Sanduk::zadnji = 0;           // Zadnji u listi svih sanduka.
