// sanduk.h - Deklaracije podataka i funkcija za rad sa sanducima.

#ifndef _sanduk_h_
#define _sanduk_h_

class Sanduk {
public:
  enum Stanje { PRAZAN, PORUKA, PROCES };

private:
			   // SANDUK:
  Sanduk *sledeci;         // Sledeci u listi svih sanduka.
  Sanduk *prethodni;       // Prethodni u listi svih sanduka.
  char   *ime;             // Ime sanduka.
  int     broj;            // Broj korisnika sanduka.
  Stanje  stanje;          // Stanje sanduka.
  void   *poc, *kraj;      // Lista poruka ili procesa.

public:

  void sis_salji (const void *, int); // Slanje poruke.
  static void    salji ();
  void sis_primi (void *, int &);     // Prijem poruke.
  static void    primi ();
  Stanje sis_stanje ();               // Ispitivanje stanja sanduka.
  static void   stanje_ ();

  static Sanduk *sis_novi (const char *);   // Formiranje sanduka (+ otv.).
  static void        novi ();
  static Sanduk *sis_otvori (const char *); // Pocetak rada sa sandukom.
  static void        otvori ();
	 void    sis_zatvori ();            // Kraj rada sa sandukom.
  static void    zatvori ();
  static int sis_brisi (const char *);      // Brisanje sanduka.
  static void    brisi ();

private:
  static Sanduk *nadji (const char *);      // Nalazenje sanduka po imenu.

  static Sanduk *prvi;                // Prvi u listi svih sanduka.
  static Sanduk *zadnji;              // Zadnji u listi svih sanduka.


  struct Poruka {          // PORUKA:
    Poruka *sledeci;       // Sledeci u listi poruka.
    int     duzina;        // Duzina poruke.
    char   *sadrzaj;       // Sadrzaj poruke.
  };

};

#endif
