// semafor.h - Deklaracije podataka i funkcija za rad sa semaforima

#ifndef _semafor_h_
#define _semafor_h_

#include "proces.h"
#include "sistem.h"

class Semafor {
  int  vrednost;                     // Vrednost semafora.
  Proces *prvi;                      // Prvi proces koji ceka.
  Proces *zadnji;                    // Zadnji proces koji ceka.

public:
  Semafor (int vr=0) {               // Pocetna vrednost semafora.
    vrednost = vr; prvi = zadnji = 0;
  }
  ~Semafor ();                       // Unistavanje semafora.

  void sis_wait   ();                // Primitiva WAIT.
  static void wait   ();
  void sis_signal ();                // Primitiva SIGNAL.
  static void signal ();
  int stanje () { return vrednost; } // Stanje semafora.
};

#endif
