// semafor.cpp - Metode za rad sa semaforima.

#include "semafor.h"
#include <iostream.h>
#include <stdlib.h>

Semafor::~Semafor () {
  if (prvi) {
    cerr << "*** Pokusaj unistavanja nepraznog semafora! ***" << endl;
    exit (99);
  }
}

void Semafor::sis_wait   () {                // Primitiva WAIT.
  Sistem::poziv_os (Sistem::WAIT, this);
}

void Semafor::    wait   () {
  Semafor *s = (Semafor *) Sistem::par1;
  if (--(s->vrednost) < 0) {
    Proces::blokiraj (s->prvi, s->zadnji);
    Proces::oduzmi_procesor();
  }
}

void Semafor::sis_signal () {                // Primitiva SIGNAL.
  Sistem::poziv_os (Sistem::SIGNAL, this);
}

void Semafor::    signal () {
  Semafor *s = (Semafor *) Sistem::par1;
  if (++(s->vrednost) <= 0) {
    Proces *proc = s->prvi;
    if ((s->prvi = proc->sledeci) == 0) s->zadnji = 0;
    Proces::stavi_spreman (proc);
    // Proces::stavi_spreman (Proces::radi);    Varijanta sa vracanjem
    // Proces::stavi_spreman (proc);            procesu viseg
    // Proces::oduzmi_procesor ();              prioriteta.
  }
}
