// bafer2.h - Kruzni bafer sa deljenom memorijom Bafer.

#ifndef __bafer__h__
#define __bafer__h__
#include "region.h";
#include "semaphor.h"
#include "shared.h"

class Bafer {
  struct Baf { int kap, duz, ulaz, izlaz, niz[1]; };
  Baf *baf;
  Region moze;
  Semaphore prazan, pun;
  Shared mem;
public:
  Bafer (int k):
    moze("moze"), prazan(k, "prazan"), pun(0, "pun"),
    mem (sizeof(Baf)+(k-1)*sizeof(int), "mem")
  { baf = (Baf*) mem.address ();
    if (mem.empty ()) {
      baf->ulaz = baf->izlaz = baf->duz = 0;
      baf->kap = k;
    }
  }
  void stavi (int i) {
    prazan.wait ();
    moze.wait ();
      baf->niz[baf->ulaz++] = i; baf->duz++;
      if (baf->ulaz == baf->kap) baf->ulaz = 0;
    moze.signal ();
    pun.signal ();
  }
  int uzmi () {
    pun.wait ();
    moze.wait ();
      int i = baf->niz[baf->izlaz++]; baf->duz--;
      if (baf->izlaz == baf->kap) baf->izlaz = 0;
    moze.signal ();
    prazan.signal ();
    return i;
  }
  void stanje ();
  void parzni ();
  ~Bafer () {}
};
#endif
