// event.h - Dogadjaj za sinhronizaciju procesa (Event).

#include <wtypes.h>
#include <winbase.h>
#include <string.h>

class Event {
public:
  HANDLE rucka;
public:
  Event (char *_ime=NULL) {
    if ((rucka = CreateEvent (NULL, TRUE, FALSE, _ime)) == 0)
      throw GetLastError ();
  }
  BOOL wait (DWORD _vreme=INFINITE) {
    DWORD uspeh = WaitForSingleObject (rucka, _vreme);
    if (uspeh == WAIT_FAILED) throw GetLastError ();
    return uspeh != WAIT_TIMEOUT;
  }
  void signal () { if (! PulseEvent (rucka)) throw GetLastError (); }
  void unlock () { if (! SetEvent   (rucka)) throw GetLastError (); }
  void lock   () { if (! ResetEvent (rucka)) throw GetLastError (); }
  ~Event () { if (! CloseHandle (rucka)) throw GetLastError (); }
};
