// semaphor.h - Semafor za sinhronizaciju procesa (Semaphore).

#ifndef __semaphor__h__
#define __semaphor__h__
#include <wtypes.h>
#include <winbase.h>
#include <string.h>

class Semaphore {
public:
  HANDLE rucka;
public:
  Semaphore (int _broj, LPCSTR _ime=NULL) {
    if ((rucka=CreateSemaphore (NULL, _broj, 0x0fffffff, _ime))==0)
      throw GetLastError ();
  }
  BOOL wait (DWORD _vreme=INFINITE) {
    DWORD uspeh = WaitForSingleObject (rucka, _vreme);
    if (uspeh == WAIT_FAILED) throw GetLastError ();
    return uspeh != WAIT_TIMEOUT;
  }
  void signal ()
    { if (! ReleaseSemaphore(rucka,1,NULL)) throw GetLastError(); }
  ~Semaphore () { if (! CloseHandle (rucka)) throw GetLastError (); }
};
#endif