// shared.h - Deljena memorija medju procesima (Shared).

#ifndef __shared__h__
#define __shared__h__
#include <wtypes.h>
#include <winbase.h>

class Shared {
  HANDLE rucka; LPVOID memor; BOOL old;
public:
  Shared (DWORD _velicina, LPCSTR _ime) {
     if ((rucka = CreateFileMapping( (HANDLE)0xffffffff, NULL,
          PAGE_READWRITE, 0L, _velicina, _ime)) == NULL)
       throw GetLastError ();
     old = GetLastError () == ERROR_ALREADY_EXISTS;
     if ((memor = MapViewOfFile(rucka, FILE_MAP_WRITE, 0L, 0L,
          _velicina)) == NULL)
       throw GetLastError ();
  }
  LPVOID address () { return memor; }
  BOOL empty () { return ! old; }
  ~Shared () {
    if (! UnmapViewOfFile (memor) ||
        ! CloseHandle (rucka)        ) throw GetLastError ();
  }
};

#endif