/* proces.h - Deklaracije podataka i funkcija za obradu procesa.          */

#ifndef _proces_h_
#define _proces_h_
#include "stranica.h"
#include <stdio.h>

typedef enum { PROC_RADI, PROC_SPREMAN, PROC_BLOKIRAN } Proc_stanje;

typedef struct pcb {               /* KONTROLNI BLOK PROCESA:             */
          struct pcb *sledeci;     /* Sledeci u raznim listama procesa.   */
          struct pcb *naredni;     /* Naredni u listi svih procesa.       */
          int         ident;       /* Identifikator procesa.              */
          int         prio;        /* Prioritet procesa.                  */
          Proc_stanje stanje;      /* Stanje procesa.                     */
          void       *sp;          /* Ocuvani pokazivac steka.            */
          void       *pokaz;       /* Pokazivac opste namene.             */

          char       *program;     /* Ime datoteke sa programom.          */

          /*      Podaci za stranicnu organizaciju memorije.              */
          Ulong       str_duz;     /* Duzina stranicne tablice.           */
          Str_ulaz   *str_tabl;    /* Stranicna tablica.                  */
          FILE       *str_datot;   /* Datoteka za kopije stranica.        */

          /*                 Ostali sadrzaj PCB-a.                        */
        } Pcb;

extern Pcb  *proc_prvi;            /* Prvi u listi svih procesa.          */
extern Pcb  *proc_zadnji;          /* Zadnji u listi svih procesa.        */
extern Pcb  *proc_spreman;         /* Prvi u listi spremnih procesa.      */
extern Pcb  *proc_radi;            /* Proces u stanju radi.               */
extern void *proc_sp;              /* Ocuvani SP procesa.                 */
extern int   proc_kvant;           /* Kvant vremena [ms].                 */

int  cuvaj_kontekst  (void);       /* SMJ                                 */
void obnovi_kontekst (void);       /* SMJ                                 */
void stavi_spreman   (Pcb *);
void oduzmi_procesor (void);
void podesi_casovnik (void);       /* SMJ                                 */
void dodeli_procesor (void);
void promeni_proces  (void);
void istekao_kvant   (void);       /* obrada prekida                      */

#endif
