// vreme.cpp - Prikazivanje vremena na ekranu.

#include "vreme.h"
#include <dos.h>
#include <conio.h>

unsigned char Vreme::sek = 255, Vreme::min = 255, Vreme::sat = 255;
Vreme::PRutina Vreme::stara = 0;

void interrupt Vreme::radi (...) {
  // (*stara) ();
  // enable ();
  union REGS reg = {{0}}; reg.h.ah = 0x02;
  int86 (0x1a, &reg, &reg);
  if (reg.h.dh != sek) {
    sek = reg.h.dh; min = reg.h.cl; sat = reg.h.ch;
    struct text_info stanje; gettextinfo (&stanje);
    textattr((BLUE<<4) | WHITE);
    gotoxy ((stanje.screenwidth - 4), 1);
    cprintf ("%d%d:%d%d", sat>>4, sat&15, min>>4, min&15);
    textattr (stanje.attribute);
    gotoxy (stanje.curx, stanje.cury);
  }
}

void Vreme::pokreni () {
  stara = getvect (0x1c);
  setvect (0x1c, &radi);
}

void Vreme::zaustavi () {
  setvect (0x1c, stara);
}

void Vreme::uzmi (int &h, int &m, int &s) {
  h = (sat >> 4) * 10 + (sat & 15);
  m = (min >> 4) * 10 + (min & 15);
  s = (sek >> 4) * 10 + (sek & 15);
}
